	cpu LMM
	.module cmd.c
	.area data(ram, con, rel)
_errmsg::
	.word L1
	.word L2
	.word L3
	.word L4
	.dbfile ./cmd.c
	.dbsym e errmsg _errmsg A[8:4]pc
	.area data(ram, con, rel)
	.dbfile ./cmd.c
	.area text(rom, con, rel)
	.dbfile ./cmd.c
	.dbfunc e skipspace _skipspace fV
_skipspace::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 23
; //========================================
; //==	R}hvZbT		==
; //==					==
; //========================================
; 
; #include <m8c.h>
; #include "ctype.h"
; #include "cstdef.h"
; #include "print.h"
; #include "mmc.h"
; 
; 
; unsigned char *cmdptr;
; unsigned char cmdsts;
; const unsigned char *errmsg[] = {	// G[bZ[We[u
; 	"",
; 	"?VALUE\r\n",
; 	"?CMD\r\n",
; 	"?TIMEOUT\r\n"
; };
; 
; void skipspace(void)
; {
	xjmp L7
L6:
	.dbline 25
	mov REG[0xd0],>_cmdptr
	inc [_cmdptr+1]
	adc [_cmdptr],0
L7:
	.dbline 24
; 	while(isspace(*cmdptr))
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],16
	jnz L10
	mov [X+1],0
	mov [X+0],0
	xjmp L11
L10:
	mov [X+1],1
	mov [X+0],0
L11:
	cmp [X+0],0
	jnz L6
	cmp [X+1],0
	jnz L6
X0:
	.dbline -2
	.dbline 26
; 		cmdptr++;
; }
L5:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e hexatoi _hexatoi fc
;              c -> X-4
_hexatoi::
	.dbline -1
	push X
	mov X,SP
	.dbline 33
; 
; 
; //----------------------------------------
; //-- '0'`'9'A'A'`'F'0x0`0xFɕϊ	--
; //----------------------------------------
; unsigned char hexatoi(unsigned char c)
; {
	.dbline 34
; 	if ((c >= '0') && (c <= '9'))
	cmp [X-4],48
	jc L13
X1:
	mov A,57
	cmp A,[X-4]
	jc L13
X2:
	.dbline 35
; 		return(c - '0');
	mov REG[0xd0],>__r0
	mov A,[X-4]
	sub A,48
	xjmp L12
L13:
	.dbline 36
; 	if ((c >= 'A') && (c <= 'F'))
	cmp [X-4],65
	jc L15
X3:
	mov A,70
	cmp A,[X-4]
	jc L15
X4:
	.dbline 37
; 		return(c - 'A' + 10);
	mov REG[0xd0],>__r0
	mov A,[X-4]
	sub A,65
	mov [__r0],A
	add [__r0],10
	mov A,[__r0]
	xjmp L12
L15:
	.dbline 38
; 	if ((c >= 'a') && (c <= 'f'))
	cmp [X-4],97
	jc L17
X5:
	mov A,102
	cmp A,[X-4]
	jc L17
X6:
	.dbline 39
; 		return(c - 'a' + 10);
	mov REG[0xd0],>__r0
	mov A,[X-4]
	sub A,97
	mov [__r0],A
	add [__r0],10
	mov A,[__r0]
	xjmp L12
L17:
	.dbline 40
; 	return (0);
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L12:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c -4 c
	.dbend
	.dbfunc e get2hex _get2hex fc
;         retdat -> X+0
_get2hex::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 48
; }
; 
; //--------------------------------
; //--	16i񌅂̎擾		--
; //-- 擪̃[TvX͏ȗ	--
; //--------------------------------
; unsigned char get2hex()
; {
	.dbline 50
; 	unsigned char retdat;
; 	skipspace();
	xcall _skipspace
	.dbline 51
; 	if (!(isxdigit(*cmdptr))) {	// 擪16iłȂG[I
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],8
	jnz L23
	mov [X+2],0
	mov [X+1],0
	xjmp L24
L23:
	mov [X+2],1
	mov [X+1],0
L24:
	cmp [X+1],0
	jnz L20
	cmp [X+2],0
	jnz L20
X7:
	.dbline 51
	.dbline 52
; 		cmdsts = E_ERRVAL;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],1
	.dbline 53
; 		return(0);
	mov REG[0xd0],>__r0
	mov A,0
	xjmp L19
L20:
	.dbline 55
; 	}
; 	retdat = hexatoi(*cmdptr++);	// ꌅڂ̎擾
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	dec [__r1]
	push A
	xcall _hexatoi
	add SP,-1
	mov [X+0],A
	.dbline 56
; 	if (isxdigit(*cmdptr))		// 񌅖ڂΎ擾
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],8
	jnz L28
	mov [X+4],0
	mov [X+3],0
	xjmp L29
L28:
	mov [X+4],1
	mov [X+3],0
L29:
	cmp [X+3],0
	jnz X8
	cmp [X+4],0
	jz L25
X8:
	.dbline 57
; 		retdat = retdat * 0x10 + hexatoi(*cmdptr++);
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	dec [__r1]
	push A
	xcall _hexatoi
	add SP,-1
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X+0]
	asl A
	asl A
	asl A
	asl A
	add A,[__r0]
	mov [X+0],A
L25:
	.dbline 58
; 	return(retdat);
	mov A,[X+0]
	mov REG[0xd0],>__r0
	.dbline -2
L19:
	add SP,-5
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l retdat 0 c
	.dbend
	.dbfunc e get4hex _get4hex fi
;              i -> X+2
;         retdat -> X+0
_get4hex::
	.dbline -1
	push X
	mov X,SP
	add SP,7
	.dbline 66
; }
; 
; //--------------------------------
; //--	16il̎擾		--
; //-- 擪̃[TvX͏ȗ	--
; //--------------------------------
; unsigned int get4hex()
; {
	.dbline 69
; 	unsigned char	i;
; 	unsigned int	retdat;
; 	skipspace();
	xcall _skipspace
	.dbline 70
; 	if (!(isxdigit(*cmdptr))) {	// 擪16iłȂG[I
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],8
	jnz L34
	mov [X+4],0
	mov [X+3],0
	xjmp L35
L34:
	mov [X+4],1
	mov [X+3],0
L35:
	cmp [X+3],0
	jnz L31
	cmp [X+4],0
	jnz L31
X9:
	.dbline 70
	.dbline 71
; 		cmdsts = E_ERRVAL;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],1
	.dbline 72
; 		return(0);
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
	xjmp L30
L31:
	.dbline 74
; 	}
; 	retdat = hexatoi(*cmdptr++);	// ꌅڂ̎擾
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	dec [__r1]
	push A
	xcall _hexatoi
	add SP,-1
	mov REG[0xd0],>__r0
	mov [X+1],A
	mov [X+0],0
	.dbline 75
	mov [X+2],0
	xjmp L39
L36:
	.dbline 75
; 	for (i=0; i<3; i++) {		// 񌅖ڈȍ~̎擾
	.dbline 76
; 		if (!(isxdigit(*cmdptr)))
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],8
	jnz L43
	mov [X+6],0
	mov [X+5],0
	xjmp L44
L43:
	mov [X+6],1
	mov [X+5],0
L44:
	cmp [X+5],0
	jnz L40
	cmp [X+6],0
	jnz L40
X10:
	.dbline 77
; 			break;
	xjmp L38
L40:
	.dbline 78
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	dec [__r1]
	push A
	xcall _hexatoi
	add SP,-1
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov [__r0],0
	mov A,[X+1]
	mov [__r3],A
	mov A,[X+0]
	mov [__r2],A
	asl [__r3]
	rlc [__r2]
	asl [__r3]
	rlc [__r2]
	asl [__r3]
	rlc [__r2]
	asl [__r3]
	rlc [__r2]
	mov A,[__r3]
	add A,[__r1]
	mov [X+1],A
	mov A,[__r2]
	adc A,[__r0]
	mov [X+0],A
	.dbline 79
L37:
	.dbline 75
	inc [X+2]
L39:
	.dbline 75
	cmp [X+2],3
	jc L36
X11:
L38:
	.dbline 80
; 		retdat = retdat * 0x10 + hexatoi(*cmdptr++);
; 	}
; 	return(retdat);
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	.dbline -2
L30:
	add SP,-7
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l i 2 c
	.dbsym l retdat 0 i
	.dbend
	.dbfunc e getdeci _getdeci fi
;         retdat -> X+0
_getdeci::
	.dbline -1
	push X
	mov X,SP
	add SP,6
	.dbline 87
; }
; 
; //--------------------------------
; //--	10i̎擾		--
; //--------------------------------
; unsigned int getdeci(void)
; {
	.dbline 89
; 	unsigned int retdat;
; 	skipspace();
	xcall _skipspace
	.dbline 90
; 	if (!(isdigit(*cmdptr))) {	// 擪10iłȂG[I
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],4
	jnz L49
	mov [X+3],0
	mov [X+2],0
	xjmp L50
L49:
	mov [X+3],1
	mov [X+2],0
L50:
	cmp [X+2],0
	jnz L46
	cmp [X+3],0
	jnz L46
X12:
	.dbline 90
	.dbline 91
; 		cmdsts = E_ERRVAL;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],1
	.dbline 92
; 		return(0);
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
	xjmp L45
L46:
	.dbline 94
; 	}
; 	retdat = (*cmdptr++)-'0';	// ꌅڂ̎擾
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	sub [__r1],48
	sbb [__r0],0
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	xjmp L52
L51:
	.dbline 96
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,0
	push A
	mov A,10
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [__r3],A
	mov A,[__rY]
	mov [__r2],A
	mov A,[__r3]
	add A,[__r1]
	mov [__r1],A
	mov A,[__r2]
	adc A,[__r0]
	mov [__r0],A
	mov A,[__r1]
	sub A,48
	mov [X+1],A
	mov A,[__r0]
	sbb A,0
	mov [X+0],A
L52:
	.dbline 95
; 	while(isdigit(*cmdptr))	// 񌅖ڈȍ~Ύ擾
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<__ctypes
	adc [__r0],>__ctypes
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	tst [__r0],4
	jnz L55
	mov [X+5],0
	mov [X+4],0
	xjmp L56
L55:
	mov [X+5],1
	mov [X+4],0
L56:
	cmp [X+4],0
	jnz L51
	cmp [X+5],0
	jnz L51
X13:
	.dbline 97
; 		retdat = retdat * 10 + (*cmdptr++) - '0';
; 	return(retdat);
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	.dbline -2
L45:
	add SP,-6
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l retdat 0 i
	.dbend
	.dbfunc e exec_port _exec_port fV
;            dat -> X+2
;           pnum -> X+0
_exec_port::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 102
; }
; 
; 
; void exec_port(void)
; {
	.dbline 105
; 	unsigned int	pnum;
; 	unsigned char	dat;
; 	pnum = get2hex();
	xcall _get2hex
	mov [X+1],A
	mov [X+0],0
	.dbline 106
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L58
	.dbline 107
; 		return;
	xjmp L57
L58:
	.dbline 108
; 	skipspace();
	xcall _skipspace
	.dbline 109
; 	if (*cmdptr == '=') {	// Ȃ珑
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,61
	jnz L60
	.dbline 109
	.dbline 110
; 		cmdptr++;
	mov REG[0xd0],>_cmdptr
	inc [_cmdptr+1]
	adc [_cmdptr],0
	.dbline 111
; 		dat = get2hex();
	xcall _get2hex
	mov [X+2],A
	.dbline 112
; 		if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L62
	.dbline 113
; 			return;
	xjmp L57
L62:
	.dbline 114
	cmp [X+0],0
	jnz X16
	cmp [X+1],0
	jz L66
X16:
	cmp [X+0],0
	jnz X17
	cmp [X+1],1
	jz L67
X17:
	cmp [X+0],0
	jnz X18
	cmp [X+1],2
	jz L68
X18:
	cmp [X+0],0
	jnz X19
	cmp [X+1],3
	jz L69
X19:
	cmp [X+0],0
	jnz X20
	cmp [X+1],4
	jz L70
X20:
	cmp [X+0],0
	jnz X21
	cmp [X+1],5
	jz L71
X21:
	cmp [X+0],0
	jnz X22
	cmp [X+1],7
	jz L72
X22:
	xjmp L64
X14:
	.dbline 114
; 		switch(pnum) {
L66:
	.dbline 115
; 			case	0x00:	PRT0DR = dat; break;
	mov A,[X+2]
	mov REG[ 0],A
	.dbline 115
	xjmp L65
L67:
	.dbline 116
; 			case	0x01:	PRT1DR = dat; break;
	mov A,[X+2]
	mov REG[0x4],A
	.dbline 116
	xjmp L65
L68:
	.dbline 117
; 			case	0x02:	PRT2DR = dat; break;
	mov A,[X+2]
	mov REG[0x8],A
	.dbline 117
	xjmp L65
L69:
	.dbline 118
; 			case	0x03:	PRT3DR = dat; break;
	mov A,[X+2]
	mov REG[0xc],A
	.dbline 118
	xjmp L65
L70:
	.dbline 119
; 			case	0x04:	PRT4DR = dat; break;
	mov A,[X+2]
	mov REG[0x10],A
	.dbline 119
	xjmp L65
L71:
	.dbline 120
; 			case	0x05:	PRT5DR = dat; break;
	mov A,[X+2]
	mov REG[0x14],A
	.dbline 120
	xjmp L65
L72:
	.dbline 121
; 			case	0x07:	PRT7DR = dat; break;
	mov A,[X+2]
	mov REG[0x1c],A
	.dbline 121
	xjmp L65
L64:
	.dbline 122
; 			default:	cmdsts = E_ERRVAL; break;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],1
	.dbline 122
L65:
	.dbline 124
; 		}
; 		if (cmdsts == E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jnz L61
	.dbline 125
; 			printf("Write %02X=%02X\n",pnum,dat);
	mov REG[0xd0],>__r0
	mov A,[X+2]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,>L75
	push A
	mov A,<L75
	push A
	xcall _printf
	add SP,-6
	.dbline 126
	xjmp L61
L60:
	.dbline 126
; 	} else {		// Γǂݍ
	.dbline 127
	cmp [X+0],0
	jnz X23
	cmp [X+1],0
	jz L78
X23:
	cmp [X+0],0
	jnz X24
	cmp [X+1],1
	jz L79
X24:
	cmp [X+0],0
	jnz X25
	cmp [X+1],2
	jz L80
X25:
	cmp [X+0],0
	jnz X26
	cmp [X+1],3
	jz L81
X26:
	cmp [X+0],0
	jnz X27
	cmp [X+1],4
	jz L82
X27:
	cmp [X+0],0
	jnz X28
	cmp [X+1],5
	jz L83
X28:
	cmp [X+0],0
	jnz X29
	cmp [X+1],7
	jz L84
X29:
	xjmp L76
X15:
	.dbline 127
; 		switch(pnum) {
L78:
	.dbline 128
; 			case	0x00:	dat = PRT0DR; break;
	mov A,REG[ 0]
	mov [X+2],A
	.dbline 128
	xjmp L77
L79:
	.dbline 129
; 			case	0x01:	dat = PRT1DR; break;
	mov A,REG[0x4]
	mov [X+2],A
	.dbline 129
	xjmp L77
L80:
	.dbline 130
; 			case	0x02:	dat = PRT2DR; break;
	mov A,REG[0x8]
	mov [X+2],A
	.dbline 130
	xjmp L77
L81:
	.dbline 131
; 			case	0x03:	dat = PRT3DR; break;
	mov A,REG[0xc]
	mov [X+2],A
	.dbline 131
	xjmp L77
L82:
	.dbline 132
; 			case	0x04:	dat = PRT4DR; break;
	mov A,REG[0x10]
	mov [X+2],A
	.dbline 132
	xjmp L77
L83:
	.dbline 133
; 			case	0x05:	dat = PRT5DR; break;
	mov A,REG[0x14]
	mov [X+2],A
	.dbline 133
	xjmp L77
L84:
	.dbline 134
; 			case	0x07:	dat = PRT7DR; break;
	mov A,REG[0x1c]
	mov [X+2],A
	.dbline 134
	xjmp L77
L76:
	.dbline 135
; 			default:	cmdsts = E_ERRVAL; break;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],1
	.dbline 135
L77:
	.dbline 137
; 		}
; 		if (cmdsts == E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jnz L85
	.dbline 138
; 			printf("Read  %02X:%02X\n",pnum, dat);
	mov REG[0xd0],>__r0
	mov A,[X+2]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,>L87
	push A
	mov A,<L87
	push A
	xcall _printf
	add SP,-6
L85:
	.dbline 139
L61:
	.dbline -2
	.dbline 140
; 	}
; }
L57:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 c
	.dbsym l pnum 0 i
	.dbend
	.area data(ram, con, rel)
	.dbfile ./cmd.c
_use_crc::
	.byte 0
	.dbsym e use_crc _use_crc c
	.area data(ram, con, rel)
	.dbfile ./cmd.c
	.area text(rom, con, rel)
	.dbfile ./cmd.c
	.dbfunc e exec_help _exec_help fV
_exec_help::
	.dbline -1
	.dbline 145
; 
; extern BYTE verbose_mode;
; BYTE use_crc = 0;
; void exec_help()
; {
	.dbline 146
; 	printf("Commands:-\n");
	mov A,>L89
	push A
	mov A,<L89
	push A
	xcall _printf
	add SP,-2
	.dbline 147
; 	printf("  P : Port Read/Write\n");
	mov A,>L90
	push A
	mov A,<L90
	push A
	xcall _printf
	.dbline 148
; 	printf("  Z : Reset Command (CMD0 )\n");
	mov A,>L91
	push A
	mov A,<L91
	push A
	xcall _printf
	add SP,-4
	.dbline 149
; 	printf("  Y : Ready Check   (CMD1 )\n");
	mov A,>L92
	push A
	mov A,<L92
	push A
	xcall _printf
	.dbline 150
; 	printf("  S : Read CSD      (CMD9 )\n");
	mov A,>L93
	push A
	mov A,<L93
	push A
	xcall _printf
	add SP,-4
	.dbline 151
; 	printf("  I : Read CID      (CMD10)\n");
	mov A,>L94
	push A
	mov A,<L94
	push A
	xcall _printf
	.dbline 152
; 	printf("  T : Read Status   (CMD13 )\n");
	mov A,>L95
	push A
	mov A,<L95
	push A
	xcall _printf
	add SP,-4
	.dbline 153
; 	printf("  O : Read OCR      (CMD58)\n");
	mov A,>L96
	push A
	mov A,<L96
	push A
	xcall _printf
	.dbline 154
; 	printf("  E : CRC Chk ON/OFF(CMD59) Current = ");
	mov A,>L97
	push A
	mov A,<L97
	push A
	xcall _printf
	add SP,-4
	.dbline 155
; 	if (!use_crc) {
	mov REG[0xd0],>_use_crc
	cmp [_use_crc],0
	jnz L98
	.dbline 155
	.dbline 156
; 		printf("Disable\n");
	mov A,>L100
	push A
	mov A,<L100
	push A
	xcall _printf
	add SP,-2
	.dbline 157
	xjmp L99
L98:
	.dbline 157
; 	} else {
	.dbline 158
; 		printf("Enable\n");
	mov A,>L101
	push A
	mov A,<L101
	push A
	xcall _printf
	add SP,-2
	.dbline 159
; 	}
L99:
	.dbline 160
; 	printf("  D : Send Dummy Clk(CS='H') 80 clocks\n");
	mov A,>L102
	push A
	mov A,<L102
	push A
	xcall _printf
	add SP,-2
	.dbline 161
; 	printf("  C : Send Command   <ResLen><DatLen><CMD><Par3><Par2><Par1><Par0> \n");
	mov A,>L103
	push A
	mov A,<L103
	push A
	xcall _printf
	.dbline 162
; 	printf("  R : Read  Sector(CMD11) <Adr3><Adr2><Adr1><Adr0>\n");
	mov A,>L104
	push A
	mov A,<L104
	push A
	xcall _printf
	add SP,-4
	.dbline 163
; 	printf("  W : Write Sector(CMD24) <Adr3><Adr2><Adr1><Adr0>{<Dat>}\n");
	mov A,>L105
	push A
	mov A,<L105
	push A
	xcall _printf
	.dbline 164
; 	printf("  X : Write A-D Data <Adr3><Adr2><Adr1><Adr0>{<Dat>}\n");
	mov A,>L106
	push A
	mov A,<L106
	push A
	xcall _printf
	add SP,-4
	.dbline 165
; 	printf("  A : Read A-D Data\n");
	mov A,>L107
	push A
	mov A,<L107
	push A
	xcall _printf
	.dbline 166
; 	printf("  V : Switch Verbose/Silence (Current Mode=");
	mov A,>L108
	push A
	mov A,<L108
	push A
	xcall _printf
	add SP,-4
	.dbline 167
; 	if (verbose_mode)
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	jz L109
	.dbline 168
; 		printf("'Verbose')\n");
	mov A,>L111
	push A
	mov A,<L111
	push A
	xcall _printf
	add SP,-2
	xjmp L110
L109:
	.dbline 169
	mov A,>L112
	push A
	mov A,<L112
	push A
	xcall _printf
	add SP,-2
L110:
	.dbline -2
	.dbline 170
; 	else	printf("'Silence')\n");
; }
L88:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_cmd _exec_cmd fV
	.area func_lit(rom, con, rel)
L137:
	.word L136
	.word L114
	.word L130
	.word L114
	.word L126
	.word L125
	.word L124
	.word L114
	.word L114
	.word L114
	.word L122
	.word L114
	.word L114
	.word L114
	.word L114
	.word L114
	.word L123
	.word L117
	.word L114
	.word L127
	.word L120
	.word L121
	.word L114
	.word L131
	.word L128
	.word L129
	.word L119
	.word L118
	.area text(rom, con, rel)
	.dbfile ./cmd.c
;              s -> X-5
_exec_cmd::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 176
; //----------------------------------------
; //-- R}h̃Gg		--
; //----------------------------------------
; unsigned char c;
; void exec_cmd(unsigned char *s)
; {
	.dbline 177
; 	cmdsts = E_READY;		// Xe[^XREADYɂĂX^[g
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],0
	.dbline 178
; 	cmdptr = s;
	mov REG[0xd0],>_cmdptr
	mov A,[X-4]
	mov [_cmdptr+1],A
	mov A,[X-5]
	mov [_cmdptr],A
	.dbline 179
; 	skipspace();			// 擪̃Xy[X͍폜
	xcall _skipspace
	.dbline 180
; 	c = *cmdptr;
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov REG[0xd0],>_c
	mov [_c],A
	.dbline 181
	mov REG[0xd0],>_cmdptr
	mov A,[_cmdptr+1]
	push A
	mov A,[_cmdptr]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_cmdptr
	mov [_cmdptr],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+1],A
	mov [X+0],0
	mov A,[X+1]
	sub A,63
	mov A,[X+0]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L114
X31:
	mov A,90
	sub A,[X+1]
	mov A,[X+0]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jc L114
X32:
	mov REG[0xd0],>__r0
	mov A,[X+1]
	sub A,63
	mov [__r1],A
	mov A,[X+0]
	sbb A,0
	mov [__r0],A
	asl [__r1]
	rlc [__r0]
	add [__r1],<L137
	adc [__r0],>L137
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	ret
X30:
	.dbline 181
; 	switch(*cmdptr++) {
L117:
	.dbline 182
; 		case	'P':	exec_port();	// Port Access
	xcall _exec_port
	.dbline 183
; 				break;
	xjmp L115
L118:
	.dbline 184
; 		case	'Z':	exec_reset();
	xcall _exec_reset
	.dbline 185
; 				break;
	xjmp L115
L119:
	.dbline 186
; 		case	'Y':	exec_readychk();
	xcall _exec_readychk
	.dbline 187
; 				break;
	xjmp L115
L120:
	.dbline 188
; 		case	'S':	exec_readcsd();
	xcall _exec_readcsd
	.dbline 189
; 				break;
	xjmp L115
L121:
	.dbline 190
; 		case	'T':	exec_sendstatus();
	xcall _exec_sendstatus
	.dbline 191
; 				break;
	xjmp L115
L122:
	.dbline 192
; 		case	'I':	exec_readcid();
	xcall _exec_readcid
	.dbline 193
; 				break;
	xjmp L115
L123:
	.dbline 194
; 		case	'O':	exec_readocr();
	xcall _exec_readocr
	.dbline 195
; 				break;
	xjmp L115
L124:
	.dbline 196
; 		case	'E':	exec_crconoff();
	xcall _exec_crconoff
	.dbline 197
; 				break;
	xjmp L115
L125:
	.dbline 198
; 		case	'D':	exec_dummyclk();
	xcall _exec_dummyclk
	.dbline 199
; 				break;
	xjmp L115
L126:
	.dbline 200
; 		case	'C':	exec_command();
	xcall _exec_command
	.dbline 201
; 				break;
	xjmp L115
L127:
	.dbline 202
; 		case	'R':	exec_read();
	xcall _exec_read
	.dbline 203
; 				break;
	xjmp L115
L128:
	.dbline 204
; 		case	'W':	exec_write();
	xcall _exec_write
	.dbline 205
; 				break;
	xjmp L115
L129:
	.dbline 206
; 		case	'X':	exec_adwrite();
	xcall _exec_adwrite
	.dbline 207
; 				break;
	xjmp L115
L130:
	.dbline 208
; 		case	'A':	exec_adread();
	xcall _exec_adread
	.dbline 209
; 				break;
	xjmp L115
L131:
	.dbline 210
; 		case	'V':	verbose_mode = (verbose_mode & 0x1) ^ 0x01;
	mov REG[0xd0],>_verbose_mode
	mov A,[_verbose_mode]
	and A,1
	mov REG[0xd0],>__r0
	mov [__r0],A
	xor [__r0],1
	mov A,[__r0]
	mov REG[0xd0],>_verbose_mode
	mov [_verbose_mode],A
	.dbline 211
; 				if (verbose_mode)
	cmp [_verbose_mode],0
	jz L132
	.dbline 212
; 					printf("Verbose\n");
	mov A,>L134
	push A
	mov A,<L134
	push A
	xcall _printf
	add SP,-2
	xjmp L115
L132:
	.dbline 213
; 				else	printf("Silence\n");
	mov A,>L135
	push A
	mov A,<L135
	push A
	xcall _printf
	add SP,-2
	.dbline 214
; 				break;
	xjmp L115
L136:
	.dbline 215
; 		case	'?':	exec_help();
	xcall _exec_help
	.dbline 216
; 				break;
	xjmp L115
L114:
	.dbline 217
; 		default:	cmdsts = E_ERRCMD;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],2
	.dbline 218
; 				break;
L115:
	.dbline 220
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L138
	.dbline 220
	.dbline 221
	mov A,[_cmdsts]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_errmsg
	adc [__r0],>_errmsg
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _printf
	add SP,-2
	.dbline 222
L138:
	.dbline -2
	.dbline 224
; 	}
; 	if (cmdsts != E_READY) {
; 		printf(errmsg[cmdsts]);
; 		return;
; 	}
; }
L113:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l s -5 pc
	.dbend
	.area data(ram, con, rel)
	.dbfile ./cmd.c
_c::
	.byte 0
	.dbsym e c _c c
	.area data(ram, con, rel)
	.dbfile ./cmd.c
_cmdsts::
	.byte 0
	.dbsym e cmdsts _cmdsts c
	.area data(ram, con, rel)
	.dbfile ./cmd.c
_cmdptr::
	.byte 0,0
	.dbsym e cmdptr _cmdptr pc
	.area lit(rom, con, rel)
L135:
	.byte 'S,'i,'l,'e,'n,'c,'e,10,0
L134:
	.byte 'V,'e,'r,'b,'o,'s,'e,10,0
L112:
	.byte 39,'S,'i,'l,'e,'n,'c,'e,39,41,10,0
L111:
	.byte 39,'V,'e,'r,'b,'o,'s,'e,39,41,10,0
L108:
	.byte 32,32,'V,32,58,32,'S,'w,'i,'t,'c,'h,32,'V,'e,'r
	.byte 'b,'o,'s,'e,47,'S,'i,'l,'e,'n,'c,'e,32,40,'C,'u
	.byte 'r,'r,'e,'n,'t,32,'M,'o,'d,'e,61,0
L107:
	.byte 32,32,'A,32,58,32,'R,'e,'a,'d,32,'A,45,'D,32,'D
	.byte 'a,'t,'a,10,0
L106:
	.byte 32,32,'X,32,58,32,'W,'r,'i,'t,'e,32,'A,45,'D,32
	.byte 'D,'a,'t,'a,32,60,'A,'d,'r,51,62,60,'A,'d,'r,50
	.byte 62,60,'A,'d,'r,49,62,60,'A,'d,'r,48,62,123,60,'D
	.byte 'a,'t,62,125,10,0
L105:
	.byte 32,32,'W,32,58,32,'W,'r,'i,'t,'e,32,'S,'e,'c,'t
	.byte 'o,'r,40,'C,'M,'D,50,52,41,32,60,'A,'d,'r,51,62
	.byte 60,'A,'d,'r,50,62,60,'A,'d,'r,49,62,60,'A,'d,'r
	.byte 48,62,123,60,'D,'a,'t,62,125,10,0
L104:
	.byte 32,32,'R,32,58,32,'R,'e,'a,'d,32,32,'S,'e,'c,'t
	.byte 'o,'r,40,'C,'M,'D,49,49,41,32,60,'A,'d,'r,51,62
	.byte 60,'A,'d,'r,50,62,60,'A,'d,'r,49,62,60,'A,'d,'r
	.byte 48,62,10,0
L103:
	.byte 32,32,'C,32,58,32,'S,'e,'n,'d,32,'C,'o,'m,'m,'a
	.byte 'n,'d,32,32,32,60,'R,'e,'s,'L,'e,'n,62,60,'D,'a
	.byte 't,'L,'e,'n,62,60,'C,'M,'D,62,60,'P,'a,'r,51,62
	.byte 60,'P,'a,'r,50,62,60,'P,'a,'r,49,62,60,'P,'a,'r
	.byte 48,62,32,10,0
L102:
	.byte 32,32,'D,32,58,32,'S,'e,'n,'d,32,'D,'u,'m,'m,'y
	.byte 32,'C,'l,'k,40,'C,'S,61,39,'H,39,41,32,56,48,32
	.byte 'c,'l,'o,'c,'k,'s,10,0
L101:
	.byte 'E,'n,'a,'b,'l,'e,10,0
L100:
	.byte 'D,'i,'s,'a,'b,'l,'e,10,0
L97:
	.byte 32,32,'E,32,58,32,'C,'R,'C,32,'C,'h,'k,32,'O,'N
	.byte 47,'O,'F,'F,40,'C,'M,'D,53,57,41,32,'C,'u,'r,'r
	.byte 'e,'n,'t,32,61,32,0
L96:
	.byte 32,32,'O,32,58,32,'R,'e,'a,'d,32,'O,'C,'R,32,32
	.byte 32,32,32,32,40,'C,'M,'D,53,56,41,10,0
L95:
	.byte 32,32,'T,32,58,32,'R,'e,'a,'d,32,'S,'t,'a,'t,'u
	.byte 's,32,32,32,40,'C,'M,'D,49,51,32,41,10,0
L94:
	.byte 32,32,'I,32,58,32,'R,'e,'a,'d,32,'C,'I,'D,32,32
	.byte 32,32,32,32,40,'C,'M,'D,49,48,41,10,0
L93:
	.byte 32,32,'S,32,58,32,'R,'e,'a,'d,32,'C,'S,'D,32,32
	.byte 32,32,32,32,40,'C,'M,'D,57,32,41,10,0
L92:
	.byte 32,32,'Y,32,58,32,'R,'e,'a,'d,'y,32,'C,'h,'e,'c
	.byte 'k,32,32,32,40,'C,'M,'D,49,32,41,10,0
L91:
	.byte 32,32,'Z,32,58,32,'R,'e,'s,'e,'t,32,'C,'o,'m,'m
	.byte 'a,'n,'d,32,40,'C,'M,'D,48,32,41,10,0
L90:
	.byte 32,32,'P,32,58,32,'P,'o,'r,'t,32,'R,'e,'a,'d,47
	.byte 'W,'r,'i,'t,'e,10,0
L89:
	.byte 'C,'o,'m,'m,'a,'n,'d,'s,58,45,10,0
L87:
	.byte 'R,'e,'a,'d,32,32,37,48,50,'X,58,37,48,50,'X,10
	.byte 0
L75:
	.byte 'W,'r,'i,'t,'e,32,37,48,50,'X,61,37,48,50,'X,10
	.byte 0
L4:
	.byte 63,'T,'I,'M,'E,'O,'U,'T,13,10,0
L3:
	.byte 63,'C,'M,'D,13,10,0
L2:
	.byte 63,'V,'A,'L,'U,'E,13,10,0
L1:
	.byte 0
