	cpu LMM
	.module mmc.c
	.area data(ram, con, rel)
_verbose_mode::
	.byte 1
	.dbfile ./mmc.c
	.dbsym e verbose_mode _verbose_mode c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
	.area text(rom, con, rel)
	.dbfile ./mmc.c
	.dbfunc e CRC16_1_INPUTSEL _CRC16_1_INPUTSEL fV
;              c -> X-4
_CRC16_1_INPUTSEL::
	.dbline -1
	push X
	mov X,SP
	.dbline 28
; #include "PSoCAPI.h"
; #include "print.h"
; #include "cmd.h"
; #include "cstdef.h"
; #include "cstdio.h"
; #include "ctype.h"
; 
; #define	RO_1	0x90
; #define	RI_3	0xf0
; extern unsigned char secbuf[];
; 
; 
; #define	MAX_RES		5
; WORD crcdat;
; WORD wcount,wi,wj,wbufpos;
; BYTE rcount;
; BYTE mmc_cmd[6];
; BYTE mmc_res[MAX_RES];
; BYTE mmc_sdtoken;	// X^[gf[^ubNg[N
; BYTE mmc_crc[2];	// CRCf[^iMlj
; BYTE mmc_dres;		// f[^X|X
; BYTE mmc_rwflag;
; WORD cal_crc;
; 
; BYTE verbose_mode = 1;
; 
; void CRC16_1_INPUTSEL(unsigned char c)
; {
	.dbline 29
; 	CRC16_1_INPUT_LSB_REG = (CRC16_1_INPUT_LSB_REG & 0x0f) | c;
	or F,0x10  ; iopage = 1
	mov A,REG[0x21]
	mov REG[0xd0],>__r0
	mov [__r0],A
	and F,0xEF ; iopage = 0
	and [__r0],15
	mov A,[X-4]
	or [__r0],A
	or F,0x10  ; iopage = 1
	mov A,[__r0]
	mov REG[0x21],A
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 30
; }
L2:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c -4 c
	.dbend
	.dbfunc e spim_wait_done _spim_wait_done fV
_spim_wait_done::
	.dbline -1
	.dbline 33
; 
; void spim_wait_done()
; {
L4:
	.dbline 35
L5:
	.dbline 34
; 	while(!(SPIM_1_bReadStatus() & SPIM_1_SPIM_SPI_COMPLETE))
	push X
	xcall _SPIM_1_bReadStatus
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	tst [__r0],32
	jz L4
	.dbline -2
	.dbline 36
; 		;
; }
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e spim_tx _spim_tx fV
;            dat -> X-4
_spim_tx::
	.dbline -1
	push X
	mov X,SP
	.dbline 39
; 
; void spim_tx(unsigned char dat)
; {
	.dbline 40
; 	SPIM_1_SendTxData(dat);
	push X
	mov A,[X-4]
	xcall _SPIM_1_SendTxData
	pop X
	.dbline 41
; 	spim_wait_done();
	xcall _spim_wait_done
	.dbline -2
	.dbline 42
; }
L7:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat -4 c
	.dbend
	.dbfunc e spim_rx _spim_rx fc
;          rxdat -> X+0
_spim_rx::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 45
; 
; unsigned char spim_rx()
; {
	.dbline 47
; 	unsigned char rxdat;
; 	spim_tx(0xff);
	mov A,-1
	push A
	xcall _spim_tx
	add SP,-1
L9:
	.dbline 49
L10:
	.dbline 48
; 	while(!(SPIM_1_bReadStatus() & SPIM_1_SPIM_RX_BUFFER_FULL))
	push X
	xcall _SPIM_1_bReadStatus
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	tst [__r0],8
	jz L9
	.dbline 50
; 		;
; 	return(SPIM_1_bReadRxData());
	push X
	xcall _SPIM_1_bReadRxData
	mov REG[0xd0],>__r0
	pop X
	.dbline -2
L8:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l rxdat 0 c
	.dbend
	.dbfunc e exec_dummyclk _exec_dummyclk fV
;              c -> X+0
_exec_dummyclk::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 55
; }
; 
; 
; void exec_dummyclk()
; {
	.dbline 57
; 	unsigned char c;
; 	PRT2DR &= ~0x10;		// CS'H'̂܂܃Q[gJ
	and REG[0x8],-17
	.dbline 58
; 	for (c=0; c<10; c++)		// 80Clock(dl̗v72Clockj
	mov [X+0],0
	xjmp L16
L13:
	.dbline 59
	mov A,-1
	push A
	xcall _spim_tx
	add SP,-1
L14:
	.dbline 58
	inc [X+0]
L16:
	.dbline 58
	cmp [X+0],10
	jc L13
X0:
	.dbline 60
; 		spim_tx(0xff);
; 	PRT2DR |= 0x10;			// Q[gĂ
	or REG[0x8],16
	.dbline -2
	.dbline 61
; }
L12:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c 0 c
	.dbend
	.dbfunc e tx_cmd _tx_cmd fV
;              c -> X+0
_tx_cmd::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 71
; 
; 
; //
; // R}hM
; // mmc_cmd[]ɓĂ5oCg̃R}h+{CRC7+'1'}𑗂
; // obt@Q[gCSȂǂ͎OɃAT[gĂ
; // mmc_cmd[5]ɂ͑CRCf[^Ă
; //
; void tx_cmd()
; {
	.dbline 73
; 	unsigned char c;
; 	CRC16_1_WriteSeed(0);	// l[iKiłȂĂ邩dȂj
	push X
	mov A,0
	mov X,A
	xcall _CRC16_1_WriteSeed
	.dbline 74
; 	CRC16_1_WritePolynomial(0x0044);		// 1000 1000 0001 0000  // 1000100 x^7+x^3+1
	mov X,0
	mov A,68
	xcall _CRC16_1_WritePolynomial
	pop X
	.dbline 75
; 	CRC16_1_INPUTSEL(RO_1);
	mov A,-112
	push A
	xcall _CRC16_1_INPUTSEL
	add SP,-1
	.dbline 76
; 	CRC16_1_Start();
	push X
	xcall _CRC16_1_Start
	pop X
	.dbline 77
	mov [X+0],0
	xjmp L21
L18:
	.dbline 77
	.dbline 78
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_mmc_cmd
	adc [__r0],>_mmc_cmd
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	push A
	xcall _spim_tx
	add SP,-1
	.dbline 79
L19:
	.dbline 77
	inc [X+0]
L21:
	.dbline 77
; 	for (c=0; c<5; c++) {
	cmp [X+0],5
	jc L18
X1:
	.dbline 80
; 		spim_tx(mmc_cmd[c]);
; 	}
; 	crcdat = CRC16_1_wReadCRC() & 0x7f;	// CRC7擾
	push X
	xcall _CRC16_1_wReadCRC
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	and A,127
	mov REG[0xd0],>_crcdat
	mov [_crcdat+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	and A,0
	mov REG[0xd0],>_crcdat
	mov [_crcdat],A
	.dbline 81
; 	crcdat = (crcdat<< 1) | 1;
	mov A,[_crcdat+1]
	push A
	mov A,[_crcdat]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	asl [__r1]
	rlc [__r0]
	mov A,[__r1]
	or A,1
	mov REG[0xd0],>_crcdat
	mov [_crcdat+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd0],>_crcdat
	mov [_crcdat],A
	.dbline 82
; 	mmc_cmd[5] = crcdat;
	mov A,[_crcdat+1]
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd+5],A
	.dbline 83
; 	spim_tx(crcdat);
	mov REG[0xd0],>_crcdat
	mov A,[_crcdat+1]
	mov REG[0xd0],>__r0
	push A
	xcall _spim_tx
	add SP,-1
	.dbline 84
; 	CRC16_1_Stop();
	push X
	xcall _CRC16_1_Stop
	pop X
	.dbline -2
	.dbline 85
; }
L17:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c 0 c
	.dbend
	.dbfunc e rx_res _rx_res fV
;            dat -> X+1
;              c -> X+0
_rx_res::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 94
; 
; //
; // X|XM
; // 0xffǂݎ̂Ă
; // rcountŎw肳ꂽTCYǂmmc_res[]Ɋi[
; //
; #define	TIMEOUT	100
; void rx_res()
; {
	.dbline 96
; 	unsigned char c,dat;
; 	if (rcount > MAX_RES)
	mov REG[0xd0],>_rcount
	mov A,5
	cmp A,[_rcount]
	jnc L24
X2:
	.dbline 97
; 		rcount = MAX_RES;
	mov REG[0xd0],>_rcount
	mov [_rcount],5
L24:
	.dbline 98
	mov [X+0],0
	xjmp L29
L26:
	.dbline 98
; 	for (c=0; c<TIMEOUT; c++) {
	.dbline 99
; 		dat = spim_rx();
	xcall _spim_rx
	mov REG[0xd0],>__r0
	mov [X+1],A
	.dbline 100
; 		if (dat != 0xff)
	cmp [X+1],-1
	jz L30
	.dbline 101
; 			break;
	xjmp L28
L30:
	.dbline 102
L27:
	.dbline 98
	inc [X+0]
L29:
	.dbline 98
	cmp [X+0],100
	jc L26
X3:
L28:
	.dbline 103
; 	}
; 	if (c >= TIMEOUT) {
	cmp [X+0],100
	jc L32
X4:
	.dbline 103
	.dbline 104
; 		cmdsts = E_TIMEOUT;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],3
	.dbline 105
; 		return;
	xjmp L23
L32:
	.dbline 107
; 	}
; 	mmc_res[0] = dat;
	mov A,[X+1]
	mov REG[0xd0],>_mmc_res
	mov [_mmc_res],A
	.dbline 108
	mov [X+0],1
	xjmp L37
L34:
	.dbline 108
	.dbline 109
	xcall _spim_rx
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_mmc_res
	adc [__r2],>_mmc_res
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 110
L35:
	.dbline 108
	inc [X+0]
L37:
	.dbline 108
; 	for (c=1; c<rcount; c++) {
	mov REG[0xd0],>_rcount
	mov A,[X+0]
	cmp A,[_rcount]
	jc L34
X5:
	.dbline -2
	.dbline 111
; 		mmc_res[c] = spim_rx();
; 	}
; }
L23:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e read_sector _read_sector fV
;            dat -> X+1
;              c -> X+0
_read_sector::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 120
; 
; //
; // f[^M
; //
; // 0xffȊOǂݎꂽƂ납
; // wcountoCgǂ
; //
; void read_sector()
; {
	.dbline 122
; 	unsigned char c,dat;
; 	CRC16_1_WriteSeed(0);
	push X
	mov A,0
	mov X,A
	xcall _CRC16_1_WriteSeed
	.dbline 124
; 	//----CRC16_1_WritePolynomial(0x0044);		// 1000100 x^7+x^3+1
; 	CRC16_1_WritePolynomial(0x8810);		// 1000 1000 0001 0000  x^16+x^12+x^5+1
	mov X,-120
	mov A,16
	xcall _CRC16_1_WritePolynomial
	pop X
	.dbline 125
; 	CRC16_1_INPUTSEL(RI_3);
	mov A,-16
	push A
	xcall _CRC16_1_INPUTSEL
	add SP,-1
	.dbline 126
; 	c = 0;
	mov [X+0],0
	.dbline 127
	mov [X+0],0
	xjmp L42
L39:
	.dbline 127
; 	for (c=0; c<TIMEOUT; c++) {
	.dbline 128
; 		dat = spim_rx();
	xcall _spim_rx
	mov REG[0xd0],>__r0
	mov [X+1],A
	.dbline 129
; 		if (dat != 0xff)
	cmp [X+1],-1
	jz L43
	.dbline 130
; 		break;
	xjmp L41
L43:
	.dbline 131
L40:
	.dbline 127
	inc [X+0]
L42:
	.dbline 127
	cmp [X+0],100
	jc L39
X6:
L41:
	.dbline 132
; 	}
; 	if (c >= TIMEOUT) {
	cmp [X+0],100
	jc L45
X7:
	.dbline 132
	.dbline 133
; 		cmdsts = E_TIMEOUT;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],3
	.dbline 134
; 		return;
	xjmp L38
L45:
	.dbline 136
; 	}
; 	mmc_sdtoken = dat;		// X^[gf[^ubNg[N
	mov A,[X+1]
	mov REG[0xd0],>_mmc_sdtoken
	mov [_mmc_sdtoken],A
	.dbline 138
; 
; 	CRC16_1_Start();		// CRCvZJn
	push X
	xcall _CRC16_1_Start
	pop X
	.dbline 139
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L50
L47:
	.dbline 139
	.dbline 140
	xcall _spim_rx
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 141
L48:
	.dbline 139
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
L50:
	.dbline 139
; 	for (wi=0; wi<wcount; wi++) {
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	mov REG[0xd0],>_wcount
	sub A,[_wcount+1]
	mov REG[0xd0],>_wi
	mov A,[_wi]
	mov REG[0xd0],>_wcount
	sbb A,[_wcount]
	jc L47
X8:
	.dbline 142
; 		secbuf[wi] = spim_rx();
; 	}
; 	cal_crc = CRC16_1_wReadCRC();	// vZłCRC擾
	push X
	xcall _CRC16_1_wReadCRC
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	push A
	mov A,[__r0]
	mov REG[0xd0],>_cal_crc
	mov [_cal_crc],A
	pop A
	mov [_cal_crc+1],A
	.dbline 143
; 	mmc_crc[0] = spim_rx();		// CRC16tĂ͂
	xcall _spim_rx
	mov REG[0xd0],>_mmc_crc
	mov [_mmc_crc],A
	.dbline 144
; 	mmc_crc[1] = spim_rx();
	xcall _spim_rx
	mov REG[0xd0],>_mmc_crc
	mov [_mmc_crc+1],A
	.dbline 145
; 	crcdat = CRC16_1_wReadCRC();	// vZłCRC擾
	push X
	xcall _CRC16_1_wReadCRC
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	push A
	mov A,[__r0]
	mov REG[0xd0],>_crcdat
	mov [_crcdat],A
	pop A
	mov [_crcdat+1],A
	.dbline 146
; 	CRC16_1_Stop();
	push X
	xcall _CRC16_1_Stop
	pop X
	.dbline -2
	.dbline 147
; }
L38:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e write_sector _write_sector fV
;            dat -> X+1
;              c -> X+0
_write_sector::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 156
; 
; //
; // f[^M
; //
; // 0xffȊOǂݎꂽƂ납
; // wcountoCg
; //
; void write_sector()
; {
	.dbline 158
; 	unsigned char c,dat;
; 	CRC16_1_WriteSeed(0);
	push X
	mov A,0
	mov X,A
	xcall _CRC16_1_WriteSeed
	.dbline 159
; 	CRC16_1_WritePolynomial(0x8810);		// 1000 1000 0001 0000  x^16+x^12+x^5+1
	mov X,-120
	mov A,16
	xcall _CRC16_1_WritePolynomial
	pop X
	.dbline 160
; 	CRC16_1_INPUTSEL(RO_1);
	mov A,-112
	push A
	xcall _CRC16_1_INPUTSEL
	.dbline 161
; 	c = 0;
	mov [X+0],0
	.dbline 162
; 	spim_tx(0xfe);			// X^[gf[^ubNg[N
	mov A,-2
	push A
	xcall _spim_tx
	add SP,-2
	.dbline 164
; 
; 	CRC16_1_Start();		// CRCvZJn
	push X
	xcall _CRC16_1_Start
	pop X
	.dbline 165
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L56
L53:
	.dbline 165
	.dbline 166
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd4],A
	mvi A,[__r1]
	push A
	xcall _spim_tx
	add SP,-1
	.dbline 167
L54:
	.dbline 165
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
L56:
	.dbline 165
; 	for (wi=0; wi<wcount; wi++) {
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	mov REG[0xd0],>_wcount
	sub A,[_wcount+1]
	mov REG[0xd0],>_wi
	mov A,[_wi]
	mov REG[0xd0],>_wcount
	sbb A,[_wcount]
	jc L53
X9:
	.dbline 168
; 		spim_tx(secbuf[wi]);
; 	}
; 	cal_crc = CRC16_1_wReadCRC();	// vZłCRC擾
	push X
	xcall _CRC16_1_wReadCRC
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	push A
	mov A,[__r0]
	mov REG[0xd0],>_cal_crc
	mov [_cal_crc],A
	pop A
	mov [_cal_crc+1],A
	.dbline 169
; 	mmc_crc[0] = (cal_crc >> 8) & 0xff;
	mov A,[_cal_crc+1]
	push A
	mov A,[_cal_crc]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov A,[__r0]
	mov [__r0],0
	and [__r0],0
	mov REG[0xd0],>_mmc_crc
	mov [_mmc_crc],A
	.dbline 170
; 	mmc_crc[1] = cal_crc & 0xff;
	mov REG[0xd0],>_cal_crc
	mov A,[_cal_crc+1]
	mov REG[0xd0],>_mmc_crc
	mov [_mmc_crc+1],A
	.dbline 171
; 	spim_tx(mmc_crc[0]);
	mov A,[_mmc_crc]
	push A
	xcall _spim_tx
	.dbline 172
; 	spim_tx(mmc_crc[1]);
	mov REG[0xd0],>_mmc_crc
	mov A,[_mmc_crc+1]
	push A
	xcall _spim_tx
	add SP,-2
	.dbline 173
; 	crcdat = CRC16_1_wReadCRC();	// vZłCRC擾
	push X
	xcall _CRC16_1_wReadCRC
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	push A
	mov A,[__r0]
	mov REG[0xd0],>_crcdat
	mov [_crcdat],A
	pop A
	mov [_crcdat+1],A
	.dbline 174
; 	CRC16_1_Stop();
	push X
	xcall _CRC16_1_Stop
	pop X
	.dbline 175
	mov [X+0],0
	xjmp L62
L59:
	.dbline 175
; 	for (c=0; c<TIMEOUT; c++) {	// X|Xf[^擾
	.dbline 176
; 		mmc_dres = spim_rx();
	xcall _spim_rx
	mov REG[0xd0],>_mmc_dres
	mov [_mmc_dres],A
	.dbline 177
; 		if (mmc_dres != 0xff)
	cmp [_mmc_dres],-1
	jz L63
	.dbline 178
; 			break;
	xjmp L61
L63:
	.dbline 179
L60:
	.dbline 175
	inc [X+0]
L62:
	.dbline 175
	cmp [X+0],100
	jc L59
X10:
L61:
	.dbline 180
; 	}
; 	if (c >= TIMEOUT) {
	cmp [X+0],100
	jc L65
X11:
	.dbline 180
	.dbline 181
; 		cmdsts = E_TIMEOUT;
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],3
	.dbline 182
; 		return;
	xjmp L52
L65:
	.dbline 184
; 	}
; 	for (c=0; (c<TIMEOUT)&&(spim_rx() != 0xff); c++)	// fBɂȂ̂҂
	mov [X+0],0
	xjmp L70
L67:
	.dbline 185
L68:
	.dbline 184
	inc [X+0]
L70:
	.dbline 184
	cmp [X+0],100
	jnc L71
X12:
	xcall _spim_rx
	mov REG[0xd0],>__r0
	cmp A,-1
	jnz L67
L71:
	.dbline 186
	cmp [X+0],100
	jc L72
X13:
	.dbline 187
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],3
L72:
	.dbline -2
	.dbline 188
; 		;
; 	if (c >= TIMEOUT)
; 		cmdsts = E_TIMEOUT;
; }
L52:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e get_param _get_param fV
;            dat -> X+1
;              c -> X+0
_get_param::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 192
; 
; 
; void get_param()
; {
	.dbline 194
; 	unsigned char c,dat;
; 	rcount = get2hex();
	xcall _get2hex
	mov REG[0xd0],>_rcount
	mov [_rcount],A
	.dbline 195
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L75
	.dbline 196
; 		return;
	xjmp L74
L75:
	.dbline 197
; 	wcount = get4hex();
	xcall _get4hex
	mov REG[0xd0],>__r0
	mov A,[__r1]
	push A
	mov A,[__r0]
	mov REG[0xd0],>_wcount
	mov [_wcount],A
	pop A
	mov [_wcount+1],A
	.dbline 198
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L77
	.dbline 199
; 		return;
	xjmp L74
L77:
	.dbline 200
; 	if (wcount >= SECBUFSIZE)
	mov REG[0xd0],>_wcount
	mov A,[_wcount+1]
	sub A,32
	mov A,[_wcount]
	sbb A,2
	jc L79
X14:
	.dbline 201
; 		wcount = SECBUFSIZE;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],32
	mov [_wcount],2
L79:
	.dbline 202
	mov [X+0],0
	xjmp L84
L81:
	.dbline 202
; 	for (c=0; c<5; c++) {
	.dbline 203
; 		dat = get2hex();
	xcall _get2hex
	mov [X+1],A
	.dbline 204
; 		if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L85
	.dbline 205
; 			break;
	xjmp L83
L85:
	.dbline 206
; 		if (c == 0) {
	cmp [X+0],0
	jnz L87
	.dbline 206
	.dbline 207
; 			dat = (dat & 0x3f) | 0x40;
	mov REG[0xd0],>__r0
	mov A,[X+1]
	and A,63
	mov [__r0],A
	or [__r0],64
	mov A,[__r0]
	mov [X+1],A
	.dbline 208
; 		}
L87:
	.dbline 209
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_mmc_cmd
	adc [__r0],>_mmc_cmd
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
	.dbline 210
L82:
	.dbline 202
	inc [X+0]
L84:
	.dbline 202
	cmp [X+0],5
	jc L81
X15:
L83:
	.dbline -2
	.dbline 211
; 		mmc_cmd[c] = dat;
; 	}
; }
L74:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e disp_buf _disp_buf fV
;            dat -> X+1
;              c -> X+0
_disp_buf::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 216
; 
; #define	MMC_READ	0
; #define	MMC_WRITE	1
; void disp_buf()
; {
	.dbline 218
; 	unsigned char c,dat;
; 	printf("\nCMD    :-");
	mov A,>L90
	push A
	mov A,<L90
	push A
	xcall _printf
	add SP,-2
	.dbline 219
; 	for (c=0; c<6; c++)
	mov [X+0],0
	xjmp L94
L91:
	.dbline 220
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_mmc_cmd
	adc [__r0],>_mmc_cmd
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L95
	push A
	mov A,<L95
	push A
	xcall _printf
	add SP,-4
L92:
	.dbline 219
	inc [X+0]
L94:
	.dbline 219
	cmp [X+0],6
	jc L91
X16:
	.dbline 221
; 		printf("%02X ",mmc_cmd[c]);
; 	printf("\nRES    :-");
	mov A,>L96
	push A
	mov A,<L96
	push A
	xcall _printf
	add SP,-2
	.dbline 222
; 	for (c=0; c< rcount; c++)
	mov [X+0],0
	xjmp L100
L97:
	.dbline 223
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_mmc_res
	adc [__r0],>_mmc_res
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L95
	push A
	mov A,<L95
	push A
	xcall _printf
	add SP,-4
L98:
	.dbline 222
	inc [X+0]
L100:
	.dbline 222
	mov REG[0xd0],>_rcount
	mov A,[X+0]
	cmp A,[_rcount]
	jc L97
X17:
	.dbline 224
; 		printf("%02X ",mmc_res[c]);
; 	if (wcount) { 			// f[^ƂL
	mov REG[0xd0],>_wcount
	cmp [_wcount],0
	jnz X18
	cmp [_wcount+1],0
	jz L101
X18:
	.dbline 224
	.dbline 225
; 		printf("\nSDTOKEN:-");
	mov A,>L103
	push A
	mov A,<L103
	push A
	xcall _printf
	add SP,-2
	.dbline 226
; 		printf("%02X",mmc_sdtoken);
	mov REG[0xd0],>_mmc_sdtoken
	mov A,[_mmc_sdtoken]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L104
	push A
	mov A,<L104
	push A
	xcall _printf
	.dbline 227
; 		printf("\nDAT    :-");
	mov A,>L105
	push A
	mov A,<L105
	push A
	xcall _printf
	add SP,-6
	.dbline 228
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L109
L106:
	.dbline 228
; 		for (wi=0; wi<wcount; wi+=16) {
	.dbline 229
; 			printf("\n");
	mov A,>L110
	push A
	mov A,<L110
	push A
	xcall _printf
	add SP,-2
	.dbline 230
; 			wj = wi;
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	push A
	mov A,[_wi]
	mov REG[0xd0],>_wj
	mov [_wj],A
	pop A
	mov [_wj+1],A
	.dbline 231
	mov [X+0],0
	xjmp L114
L111:
	.dbline 231
; 			for (c=0; c<16; c++,wj++) {
	.dbline 232
; 				if (wj < wcount)
	mov REG[0xd0],>_wj
	mov A,[_wj+1]
	mov REG[0xd0],>_wcount
	sub A,[_wcount+1]
	mov REG[0xd0],>_wj
	mov A,[_wj]
	mov REG[0xd0],>_wcount
	sbb A,[_wcount]
	jnc L115
X19:
	.dbline 233
; 					printf("%02X ",secbuf[wj]);
	mov REG[0xd0],>_wj
	mov A,[_wj+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_wj
	mov A,[_wj]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L95
	push A
	mov A,<L95
	push A
	xcall _printf
	add SP,-4
	xjmp L116
L115:
	.dbline 234
; 				else	printf("   ");
	mov A,>L117
	push A
	mov A,<L117
	push A
	xcall _printf
	add SP,-2
L116:
	.dbline 235
L112:
	.dbline 231
	inc [X+0]
	mov REG[0xd0],>_wj
	inc [_wj+1]
	adc [_wj],0
L114:
	.dbline 231
	cmp [X+0],16
	jc L111
X20:
	.dbline 236
; 			}
; 			wj = wi;
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	push A
	mov A,[_wi]
	mov REG[0xd0],>_wj
	mov [_wj],A
	pop A
	mov [_wj+1],A
	.dbline 237
	mov [X+0],0
	xjmp L121
L118:
	.dbline 237
; 			for (c=0; c<16; c++,wj++) {
	.dbline 238
; 				dat = secbuf[wj];
	mov REG[0xd0],>_wj
	mov A,[_wj+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_wj
	mov A,[_wj]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X+1],A
	.dbline 239
; 				if (wj < wcount) {
	mov REG[0xd0],>_wj
	mov A,[_wj+1]
	mov REG[0xd0],>_wcount
	sub A,[_wcount+1]
	mov REG[0xd0],>_wj
	mov A,[_wj]
	mov REG[0xd0],>_wcount
	sbb A,[_wcount]
	jnc L122
X21:
	.dbline 239
	.dbline 240
; 					if (isprint(dat))
	cmp [X+1],32
	jc L124
X22:
	mov A,126
	cmp A,[X+1]
	jc L124
X23:
	.dbline 241
; 						printf("%c",dat);
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L126
	push A
	mov A,<L126
	push A
	xcall _printf
	add SP,-4
	xjmp L125
L124:
	.dbline 242
; 					else	printf(".");
	mov A,>L127
	push A
	mov A,<L127
	push A
	xcall _printf
	add SP,-2
L125:
	.dbline 243
; 				}
L122:
	.dbline 244
L119:
	.dbline 237
	inc [X+0]
	mov REG[0xd0],>_wj
	inc [_wj+1]
	adc [_wj],0
L121:
	.dbline 237
	cmp [X+0],16
	jc L118
X24:
	.dbline 245
L107:
	.dbline 228
	mov REG[0xd0],>_wi
	add [_wi+1],16
	adc [_wi],0
L109:
	.dbline 228
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	mov REG[0xd0],>_wcount
	sub A,[_wcount+1]
	mov REG[0xd0],>_wi
	mov A,[_wi]
	mov REG[0xd0],>_wcount
	sbb A,[_wcount]
	jc L106
X25:
	.dbline 246
; 			}
; 		}
; 		if (mmc_rwflag == MMC_READ)
	mov REG[0xd0],>_mmc_rwflag
	cmp [_mmc_rwflag],0
	jnz L128
	.dbline 247
; 			printf("\nMMC CRC:-%02X%02X",mmc_crc[0], mmc_crc[1]);
	mov REG[0xd0],>_mmc_crc
	mov A,[_mmc_crc+1]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov REG[0xd0],>_mmc_crc
	mov A,[_mmc_crc]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L130
	push A
	mov A,<L130
	push A
	xcall _printf
	add SP,-6
L128:
	.dbline 248
; 		printf("\nCAL CRC:-%04X",cal_crc);
	mov REG[0xd0],>_cal_crc
	mov A,[_cal_crc]
	push A
	mov A,[_cal_crc+1]
	push A
	mov A,>L132
	push A
	mov A,<L132
	push A
	xcall _printf
	.dbline 249
; 		printf("\nSUM CRC:-%04X",crcdat);
	mov REG[0xd0],>_crcdat
	mov A,[_crcdat]
	push A
	mov A,[_crcdat+1]
	push A
	mov A,>L133
	push A
	mov A,<L133
	push A
	xcall _printf
	add SP,-8
	.dbline 250
; 	}
L101:
	.dbline 251
	mov REG[0xd0],>_mmc_rwflag
	cmp [_mmc_rwflag],1
	jnz L134
	.dbline 251
	.dbline 252
	mov REG[0xd0],>_mmc_dres
	mov A,[_mmc_dres]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L136
	push A
	mov A,<L136
	push A
	xcall _printf
	add SP,-4
	.dbline 253
L134:
	.dbline -2
	.dbline 254
; 	if (mmc_rwflag == MMC_WRITE) {
; 		printf("\nDAT RES:-%02X",mmc_dres);
; 	}
; }
L89:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e exec_mmc _exec_mmc fV
;              c -> X+0
;         rwflag -> X-4
_exec_mmc::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 257
; 
; void exec_mmc(unsigned char rwflag)
; {
	.dbline 259
; 	unsigned char c;
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L138
	.dbline 260
; 		return;
	xjmp L137
L138:
	.dbline 261
; 	mmc_rwflag = rwflag;
	mov A,[X-4]
	mov REG[0xd0],>_mmc_rwflag
	mov [_mmc_rwflag],A
	.dbline 263
; 
; 	PRT2DR &= ~0x10;	// ܂Q[gJ
	and REG[0x8],-17
	.dbline 264
; 	spim_tx(0xff);		// PLN^EFCg҂
	mov A,-1
	push A
	xcall _spim_tx
	.dbline 265
; 	PRT2DR &= ~0x01;	// CS𗎂ƂĂ
	and REG[0x8],-2
	.dbline 266
; 	spim_tx(0xff);		// ZbgAbv^C҂
	mov A,-1
	push A
	xcall _spim_tx
	add SP,-2
	.dbline 268
; 
; 	tx_cmd();		// 5oCgR}h+CRC𑗂
	xcall _tx_cmd
	.dbline 269
; 	rx_res();		// X|XM(X|XCRĈłׂ󂯁j
	xcall _rx_res
	.dbline 270
; 	if (cmdsts == E_READY) {
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jnz L140
	.dbline 270
	.dbline 271
; 		if (wcount) {	// f[^]𔺂
	mov REG[0xd0],>_wcount
	cmp [_wcount],0
	jnz X26
	cmp [_wcount+1],0
	jz L142
X26:
	.dbline 271
	.dbline 272
; 			if (mmc_rwflag == MMC_READ)
	mov REG[0xd0],>_mmc_rwflag
	cmp [_mmc_rwflag],0
	jnz L144
	.dbline 273
; 				read_sector();
	xcall _read_sector
	xjmp L145
L144:
	.dbline 274
; 			 else	write_sector();
	xcall _write_sector
L145:
	.dbline 275
; 		}
L142:
	.dbline 276
; 	}
L140:
	.dbline 277
; 	PRT2DR |= 0x01;		// CS߂
	or REG[0x8],1
	.dbline 278
; 	PRT2DR |= 0x10;		// Q[g
	or REG[0x8],16
	.dbline 279
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L146
	.dbline 280
; 		return;
	xjmp L137
L146:
	.dbline 281
; 	if (!verbose_mode)
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	.dbline 282
; 		return;
	jz L137
L148:
	.dbline 283
; 	disp_buf();
	xcall _disp_buf
	.dbline -2
	.dbline 284
; }
L137:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c 0 c
	.dbsym l rwflag -4 c
	.dbend
	.dbfunc e exec_command _exec_command fV
;            dat -> X+1
;              c -> X+0
_exec_command::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 287
; 
; void exec_command()
; {
	.dbline 289
; 	unsigned char c,dat;
; 	get_param();
	xcall _get_param
	.dbline 290
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	.dbline 291
; 		return;
	jnz L150
L151:
	.dbline 292
; 	exec_mmc(MMC_READ);
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline -2
	.dbline 293
; }
L150:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e exec_reset _exec_reset fV
_exec_reset::
	.dbline -1
	.dbline 296
; 
; void exec_reset()
; {
	.dbline 297
; 	mmc_cmd[0] = 0x40;
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],64
	.dbline 298
; 	mmc_cmd[1] = 0x00;
	mov [_mmc_cmd+1],0
	.dbline 299
; 	mmc_cmd[2] = 0x00;
	mov [_mmc_cmd+2],0
	.dbline 300
; 	mmc_cmd[3] = 0x00;
	mov [_mmc_cmd+3],0
	.dbline 301
; 	mmc_cmd[4] = 0x00;
	mov [_mmc_cmd+4],0
	.dbline 302
; 	rcount = 1;
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 303
; 	wcount = 0;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],0
	.dbline 304
; 	exec_mmc(MMC_READ);
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline -2
	.dbline 305
; }
L153:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_readychk _exec_readychk fV
_exec_readychk::
	.dbline -1
	.dbline 308
; 
; void exec_readychk()
; {
	.dbline 309
; 	mmc_cmd[0] = 0x41;
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],65
	.dbline 310
; 	mmc_cmd[1] = 0x00;
	mov [_mmc_cmd+1],0
	.dbline 311
; 	mmc_cmd[2] = 0x00;
	mov [_mmc_cmd+2],0
	.dbline 312
; 	mmc_cmd[3] = 0x00;
	mov [_mmc_cmd+3],0
	.dbline 313
; 	mmc_cmd[4] = 0x00;
	mov [_mmc_cmd+4],0
	.dbline 314
; 	rcount = 1;
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 315
; 	wcount = 0;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],0
	.dbline 316
; 	exec_mmc(MMC_READ);
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline -2
	.dbline 317
; }
L158:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e wait_ready _wait_ready fV
;              c -> X+0
_wait_ready::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 320
; 
; void wait_ready()
; {
	.dbline 322
	mov [X+0],0
	xjmp L167
L164:
	.dbline 322
; 	unsigned char c;
; 	for (c=0; c<TIMEOUT; c++) {
	.dbline 323
; 		exec_readychk();
	xcall _exec_readychk
	.dbline 324
; 		if ((mmc_res[0] & 1) == 0)
	mov REG[0xd0],>_mmc_res
	tst [_mmc_res],1
	jnz L168
	.dbline 325
; 			break;
	xjmp L166
L168:
	.dbline 326
L165:
	.dbline 322
	inc [X+0]
L167:
	.dbline 322
	cmp [X+0],100
	jc L164
X27:
L166:
	.dbline 327
	cmp [X+0],100
	jc L170
X28:
	.dbline 328
	mov REG[0xd0],>_cmdsts
	mov [_cmdsts],3
L170:
	.dbline -2
	.dbline 329
; 	}
; 	if (c >= TIMEOUT)
; 		cmdsts = E_TIMEOUT;
; }
L163:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c 0 c
	.dbend
	.dbfunc e exec_readcsd _exec_readcsd fV
_exec_readcsd::
	.dbline -1
	.dbline 333
	.dbline 334
	xcall _exec_dummyclk
	.dbline 335
	xcall _exec_reset
	.dbline 336
	xcall _wait_ready
	.dbline 337
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],73
	.dbline 338
	mov [_mmc_cmd+1],0
	.dbline 339
	mov [_mmc_cmd+2],0
	.dbline 340
	mov [_mmc_cmd+3],0
	.dbline 341
	mov [_mmc_cmd+4],0
	.dbline 342
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 343
	mov REG[0xd0],>_wcount
	mov [_wcount+1],16
	mov [_wcount],0
	.dbline 344
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline 345
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	jnz L177
	.dbline 346
	xcall _disp_buf
L177:
	.dbline -2
	.dbline 347
; 
; 
; void exec_readcsd()
; {
; 	exec_dummyclk();
; 	exec_reset();
; 	wait_ready();
; 	mmc_cmd[0] = 0x49;
; 	mmc_cmd[1] = 0x00;
; 	mmc_cmd[2] = 0x00;
; 	mmc_cmd[3] = 0x00;
; 	mmc_cmd[4] = 0x00;
; 	rcount = 0x1;
; 	wcount = 0x10;
; 	exec_mmc(MMC_READ);
; 	if (!verbose_mode)	// obt@\͂
; 		disp_buf();
; }
L172:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_readcid _exec_readcid fV
_exec_readcid::
	.dbline -1
	.dbline 350
	.dbline 351
	xcall _exec_dummyclk
	.dbline 352
	xcall _exec_reset
	.dbline 353
	xcall _wait_ready
	.dbline 354
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],74
	.dbline 355
	mov [_mmc_cmd+1],0
	.dbline 356
	mov [_mmc_cmd+2],0
	.dbline 357
	mov [_mmc_cmd+3],0
	.dbline 358
	mov [_mmc_cmd+4],0
	.dbline 359
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 360
	mov REG[0xd0],>_wcount
	mov [_wcount+1],16
	mov [_wcount],0
	.dbline 361
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline 362
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	jnz L184
	.dbline 363
	xcall _disp_buf
L184:
	.dbline -2
	.dbline 364
; 
; void exec_readcid()
; {
; 	exec_dummyclk();
; 	exec_reset();
; 	wait_ready();
; 	mmc_cmd[0] = 0x4A;
; 	mmc_cmd[1] = 0x00;
; 	mmc_cmd[2] = 0x00;
; 	mmc_cmd[3] = 0x00;
; 	mmc_cmd[4] = 0x00;
; 	rcount = 0x1;
; 	wcount = 0x10;
; 	exec_mmc(MMC_READ);
; 	if (!verbose_mode)	// obt@\͂
; 		disp_buf();
; }
L179:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_readocr _exec_readocr fV
_exec_readocr::
	.dbline -1
	.dbline 367
	.dbline 368
	xcall _exec_dummyclk
	.dbline 369
	xcall _exec_reset
	.dbline 370
	xcall _wait_ready
	.dbline 371
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],122
	.dbline 372
	mov [_mmc_cmd+1],0
	.dbline 373
	mov [_mmc_cmd+2],0
	.dbline 374
	mov [_mmc_cmd+3],0
	.dbline 375
	mov [_mmc_cmd+4],0
	.dbline 376
	mov REG[0xd0],>_rcount
	mov [_rcount],5
	.dbline 377
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],0
	.dbline 378
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline 379
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	jnz L191
	.dbline 380
	xcall _disp_buf
L191:
	.dbline -2
	.dbline 381
; 
; void exec_readocr()
; {
; 	exec_dummyclk();
; 	exec_reset();
; 	wait_ready();
; 	mmc_cmd[0] = 0x7A;
; 	mmc_cmd[1] = 0x00;
; 	mmc_cmd[2] = 0x00;
; 	mmc_cmd[3] = 0x00;
; 	mmc_cmd[4] = 0x00;
; 	rcount = 0x5;
; 	wcount = 0;
; 	exec_mmc(MMC_READ);
; 	if (!verbose_mode)	// obt@\͂
; 		disp_buf();
; }
L186:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_crconoff _exec_crconoff fV
_exec_crconoff::
	.dbline -1
	.dbline 385
; 
; extern BYTE use_crc;
; void exec_crconoff()
; {
	.dbline 386
; 	if (use_crc)
	mov REG[0xd0],>_use_crc
	cmp [_use_crc],0
	jz L194
	.dbline 387
; 		use_crc = 0;
	mov [_use_crc],0
	xjmp L195
L194:
	.dbline 388
; 	else	use_crc = 1;
	mov REG[0xd0],>_use_crc
	mov [_use_crc],1
L195:
	.dbline 389
; 	exec_dummyclk();
	xcall _exec_dummyclk
	.dbline 390
; 	exec_reset();
	xcall _exec_reset
	.dbline 391
; 	wait_ready();
	xcall _wait_ready
	.dbline 392
; 	mmc_cmd[0] = 0x7B;
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],123
	.dbline 393
; 	mmc_cmd[1] = 0x00;
	mov [_mmc_cmd+1],0
	.dbline 394
; 	mmc_cmd[2] = 0x00;
	mov [_mmc_cmd+2],0
	.dbline 395
; 	mmc_cmd[3] = 0x00;
	mov [_mmc_cmd+3],0
	.dbline 396
; 	mmc_cmd[4] = use_crc;
	mov REG[0xd0],>_use_crc
	mov A,[_use_crc]
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd+4],A
	.dbline 397
; 	rcount = 1;
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 398
; 	wcount = 0;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],0
	.dbline 399
; 	exec_mmc(MMC_READ);
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline -2
	.dbline 400
; }
L193:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_sendstatus _exec_sendstatus fV
_exec_sendstatus::
	.dbline -1
	.dbline 403
; 
; void exec_sendstatus()
; {
	.dbline 404
; 	exec_dummyclk();
	xcall _exec_dummyclk
	.dbline 405
; 	exec_reset();
	xcall _exec_reset
	.dbline 406
; 	wait_ready();
	xcall _wait_ready
	.dbline 407
; 	mmc_cmd[0] = 0x4d;
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],77
	.dbline 408
; 	mmc_cmd[1] = 0x00;
	mov [_mmc_cmd+1],0
	.dbline 409
; 	mmc_cmd[2] = 0x00;
	mov [_mmc_cmd+2],0
	.dbline 410
; 	mmc_cmd[3] = 0x00;
	mov [_mmc_cmd+3],0
	.dbline 411
; 	mmc_cmd[4] = use_crc;
	mov REG[0xd0],>_use_crc
	mov A,[_use_crc]
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd+4],A
	.dbline 412
; 	rcount = 2;
	mov REG[0xd0],>_rcount
	mov [_rcount],2
	.dbline 413
; 	wcount = 0;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],0
	.dbline 414
; 	exec_mmc(MMC_READ);
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline -2
	.dbline 415
; }
L200:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e exec_read _exec_read fV
;            dat -> X+2
;              d -> X+1
;              c -> X+0
_exec_read::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 421
; 
; //
; // 1ZN^i512oCgj[h
; //
; void exec_read()
; {
	.dbline 423
; 	unsigned char c,d,dat;
; 	exec_dummyclk();
	xcall _exec_dummyclk
	.dbline 424
; 	exec_reset();
	xcall _exec_reset
	.dbline 425
; 	wait_ready();
	xcall _wait_ready
	.dbline 426
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L206
	.dbline 427
; 		return;
	xjmp L205
L206:
	.dbline 428
; 	mmc_cmd[0] = 0x58;	// CMD24
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],88
	.dbline 429
; 	mmc_cmd[0] = 0x51;	// CMD11
	mov [_mmc_cmd],81
	.dbline 430
	mov [X+0],1
	xjmp L211
L208:
	.dbline 430
; 	for (c=1; c<5; c++) {	// SoCg擪AhX
	.dbline 431
; 		mmc_cmd[c] = get2hex();
	xcall _get2hex
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_mmc_cmd
	adc [__r2],>_mmc_cmd
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 432
; 		if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L212
	.dbline 433
; 			break;
	xjmp L210
L212:
	.dbline 434
L209:
	.dbline 430
	inc [X+0]
L211:
	.dbline 430
	cmp [X+0],5
	jc L208
X29:
L210:
	.dbline 435
; 	}
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L214
	.dbline 436
; 		return;
	xjmp L205
L214:
	.dbline 437
; 	rcount = 1;
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 438
; 	wcount = SECSIZE;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],2
	.dbline 439
; 	exec_mmc(MMC_READ);
	mov A,0
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline 440
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L216
	.dbline 441
; 		return;
	xjmp L205
L216:
	.dbline 442
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	jnz L218
	.dbline 443
	xcall _disp_buf
L218:
	.dbline -2
	.dbline 444
; 	if (!verbose_mode)	// obt@\͂
; 		disp_buf();
; }
L205:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 c
	.dbsym l d 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e exec_write _exec_write fV
;              d -> X+2
;            dat -> X+1
;              c -> X+0
_exec_write::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 450
; 
; //
; // 1ZN^i512oCgjCg
; //
; void exec_write()
; {
	.dbline 452
; 	unsigned char c,d,dat;
; 	exec_dummyclk();
	xcall _exec_dummyclk
	.dbline 453
; 	exec_reset();
	xcall _exec_reset
	.dbline 454
; 	wait_ready();
	xcall _wait_ready
	.dbline 455
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L221
	.dbline 456
; 		return;
	xjmp L220
L221:
	.dbline 457
; 	mmc_cmd[0] = 0x58;	// CMD24
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],88
	.dbline 458
	mov [X+0],1
	xjmp L226
L223:
	.dbline 458
; 	for (c=1; c<5; c++) {	// SoCg擪AhX
	.dbline 459
; 		mmc_cmd[c] = get2hex();
	xcall _get2hex
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_mmc_cmd
	adc [__r2],>_mmc_cmd
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 460
; 		if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L227
	.dbline 461
; 			break;
	xjmp L225
L227:
	.dbline 462
L224:
	.dbline 458
	inc [X+0]
L226:
	.dbline 458
	cmp [X+0],5
	jc L223
X30:
L225:
	.dbline 463
; 	}
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L229
	.dbline 464
; 		return;
	xjmp L220
L229:
	.dbline 465
; 	dat = get2hex();
	xcall _get2hex
	mov [X+1],A
	.dbline 466
; 	if (cmdsts != E_READY) {	// f[^w肪ȂANZXAhX[15:8]̃CNgf[^
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L231
	.dbline 466
	.dbline 467
; 		cmdsts = E_READY;	// G[ȂEE
	mov [_cmdsts],0
	.dbline 468
; 		dat = mmc_cmd[3];
	mov REG[0xd0],>_mmc_cmd
	mov A,[_mmc_cmd+3]
	mov [X+1],A
	.dbline 469
; 		for (wi=0; wi<SECSIZE; wi++)
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L237
L234:
	.dbline 470
	mov A,[X+1]
	mov REG[0xd0],>__r0
	mov [__r0],A
	add A,1
	mov [X+1],A
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
L235:
	.dbline 469
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
L237:
	.dbline 469
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	sub A,0
	mov A,[_wi]
	sbb A,2
	jc L234
X31:
	.dbline 471
	xjmp L232
L231:
	.dbline 471
; 			secbuf[wi] = dat++;
; 	} else {			// ȂŒf[^Ŗ߂
	.dbline 472
; 		for (wi=0; wi<SECSIZE; wi++)
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L241
L238:
	.dbline 473
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
L239:
	.dbline 472
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
L241:
	.dbline 472
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	sub A,0
	mov A,[_wi]
	sbb A,2
	jc L238
X32:
	.dbline 474
; 			secbuf[wi] = dat;
; 	}
L232:
	.dbline 475
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 476
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],2
	.dbline 477
	mov A,1
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline 478
	mov REG[0xd0],>_verbose_mode
	cmp [_verbose_mode],0
	jnz L242
	.dbline 479
	xcall _disp_buf
L242:
	.dbline -2
	.dbline 480
; 	rcount = 1;
; 	wcount = SECSIZE;
; 	exec_mmc(MMC_WRITE);
; 	if (!verbose_mode)	// obt@\͂
; 		disp_buf();
; }
L220:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l d 2 c
	.dbsym l dat 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e exec_adwrite _exec_adwrite fV
;            dat -> X+2
;              d -> X+1
;              c -> X+0
_exec_adwrite::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 486
; 
; //
; // 1ZN^i512oCgjA/Df[^݂
; //
; void exec_adwrite()
; {
	.dbline 488
; 	unsigned char c,d,dat;
; 	exec_dummyclk();
	xcall _exec_dummyclk
	.dbline 489
; 	exec_reset();
	xcall _exec_reset
	.dbline 490
; 	wait_ready();
	xcall _wait_ready
	.dbline 491
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L245
	.dbline 492
; 		return;
	xjmp L244
L245:
	.dbline 493
; 	mmc_cmd[0] = 0x58;	// CMD24
	mov REG[0xd0],>_mmc_cmd
	mov [_mmc_cmd],88
	.dbline 494
	mov [X+0],1
	xjmp L250
L247:
	.dbline 494
; 	for (c=1; c<5; c++) {	// SoCg擪AhX
	.dbline 495
; 		mmc_cmd[c] = get2hex();
	xcall _get2hex
	mov REG[0xd0],>__r0
	mov [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_mmc_cmd
	adc [__r2],>_mmc_cmd
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 496
; 		if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L251
	.dbline 497
; 			break;
	xjmp L249
L251:
	.dbline 498
L248:
	.dbline 494
	inc [X+0]
L250:
	.dbline 494
	cmp [X+0],5
	jc L247
X33:
L249:
	.dbline 499
; 	}
; 	if (cmdsts != E_READY)
	mov REG[0xd0],>_cmdsts
	cmp [_cmdsts],0
	jz L253
	.dbline 500
; 		return;
	xjmp L244
L253:
	.dbline 502
; 
; 	DelSig_1_StartAD();
	push X
	xcall _DelSig_1_StartAD
	pop X
	.dbline 503
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L258
L255:
	.dbline 503
; 	for (wi=0; wi<SECSIZE; ) {
	.dbline 504
; 		if (DelSig_1_fIsDataAvailable()) {
	push X
	xcall _DelSig_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L259
	.dbline 504
	.dbline 505
; 			secbuf[wi] = (DelSig_1_bGetDataClearFlag() << 2) ^ 0x80;
	push X
	xcall _DelSig_1_bGetDataClearFlag
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	asl [__r0]
	asl [__r0]
	xor [__r0],-128
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 506
; 			wi++;
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
	.dbline 507
; 		}
L259:
	.dbline 508
L256:
	.dbline 503
L258:
	.dbline 503
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	sub A,0
	mov A,[_wi]
	sbb A,2
	jc L255
X34:
	.dbline 509
; 	}
; 	DelSig_1_StopAD();
	push X
	xcall _DelSig_1_StopAD
	pop X
	.dbline 510
; 	rcount = 1;
	mov REG[0xd0],>_rcount
	mov [_rcount],1
	.dbline 511
; 	wcount = SECSIZE;
	mov REG[0xd0],>_wcount
	mov [_wcount+1],0
	mov [_wcount],2
	.dbline 512
; 	exec_mmc(MMC_WRITE);
	mov A,1
	push A
	xcall _exec_mmc
	add SP,-1
	.dbline -2
	.dbline 513
; }
L244:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l dat 2 c
	.dbsym l d 1 c
	.dbsym l c 0 c
	.dbend
	.dbfunc e exec_adread _exec_adread fV
;              c -> X+0
_exec_adread::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 516
; 
; void exec_adread()
; {
	.dbline 518
; 	unsigned char c;
; 	DelSig_1_StartAD();
	push X
	xcall _DelSig_1_StartAD
	pop X
	.dbline 519
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L265
L262:
	.dbline 519
; 	for (wi=0; wi<SECSIZE; ) {
	.dbline 520
; 		if (DelSig_1_fIsDataAvailable()) {
	push X
	xcall _DelSig_1_fIsDataAvailable
	mov REG[0xd0],>__r0
	pop X
	cmp A,0
	jz L266
	.dbline 520
	.dbline 521
; 			secbuf[wi] = (DelSig_1_bGetDataClearFlag()<<2) ^ 0x80;
	push X
	xcall _DelSig_1_bGetDataClearFlag
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	asl [__r0]
	asl [__r0]
	xor [__r0],-128
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r3],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 522
; 			wi++;
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
	.dbline 523
; 		}
L266:
	.dbline 524
L263:
	.dbline 519
L265:
	.dbline 519
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	sub A,0
	mov A,[_wi]
	sbb A,2
	jc L262
X35:
	.dbline 525
; 	}
; 	DelSig_1_StopAD();
	push X
	xcall _DelSig_1_StopAD
	pop X
	.dbline 526
; 	printf("\n");
	mov A,>L110
	push A
	mov A,<L110
	push A
	xcall _printf
	add SP,-2
	.dbline 527
	mov REG[0xd0],>_wi
	mov [_wi+1],0
	mov [_wi],0
	xjmp L271
L268:
	.dbline 527
; 	for (wi=0; wi<SECSIZE; ) {
	.dbline 528
	mov [X+0],0
	xjmp L275
L272:
	.dbline 528
	.dbline 529
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	add A,<_secbuf
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_wi
	mov A,[_wi]
	adc A,>_secbuf
	mov REG[0xd0],>__r0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,0
	push A
	mov A,[__r1]
	push A
	mov A,>L95
	push A
	mov A,<L95
	push A
	xcall _printf
	add SP,-4
	.dbline 530
L273:
	.dbline 528
	inc [X+0]
	mov REG[0xd0],>_wi
	inc [_wi+1]
	adc [_wi],0
L275:
	.dbline 528
	cmp [X+0],16
	jc L272
X36:
	.dbline 531
	mov A,>L110
	push A
	mov A,<L110
	push A
	xcall _printf
	add SP,-2
	.dbline 532
L269:
	.dbline 527
L271:
	.dbline 527
	mov REG[0xd0],>_wi
	mov A,[_wi+1]
	sub A,0
	mov A,[_wi]
	sbb A,2
	jc L268
X37:
	.dbline -2
	.dbline 533
; 		for (c=0; c<16; c++,wi++) {
; 			printf("%02X ",secbuf[wi]);
; 		}
; 		printf("\n");
; 	}
; }
L261:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l c 0 c
	.dbend
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_cal_crc::
	.byte 0,0
	.dbsym e cal_crc _cal_crc i
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_mmc_rwflag::
	.byte 0
	.dbsym e mmc_rwflag _mmc_rwflag c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_mmc_dres::
	.byte 0
	.dbsym e mmc_dres _mmc_dres c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_mmc_crc::
	.byte 0,0
	.dbsym e mmc_crc _mmc_crc A[2:2]c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_mmc_sdtoken::
	.byte 0
	.dbsym e mmc_sdtoken _mmc_sdtoken c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_mmc_res::
	.byte 0,0,0,0,0
	.dbsym e mmc_res _mmc_res A[5:5]c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_mmc_cmd::
	.byte 0,0,0,0,0,0
	.dbsym e mmc_cmd _mmc_cmd A[6:6]c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_rcount::
	.byte 0
	.dbsym e rcount _rcount c
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_wbufpos::
	.byte 0,0
	.dbsym e wbufpos _wbufpos i
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_wj::
	.byte 0,0
	.dbsym e wj _wj i
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_wi::
	.byte 0,0
	.dbsym e wi _wi i
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_wcount::
	.byte 0,0
	.dbsym e wcount _wcount i
	.area data(ram, con, rel)
	.dbfile ./mmc.c
_crcdat::
	.byte 0,0
	.dbsym e crcdat _crcdat i
	.area lit(rom, con, rel)
L136:
	.byte 10,'D,'A,'T,32,'R,'E,'S,58,45,37,48,50,'X,0
L133:
	.byte 10,'S,'U,'M,32,'C,'R,'C,58,45,37,48,52,'X,0
L132:
	.byte 10,'C,'A,'L,32,'C,'R,'C,58,45,37,48,52,'X,0
L130:
	.byte 10,'M,'M,'C,32,'C,'R,'C,58,45,37,48,50,'X,37,48
	.byte 50,'X,0
L127:
	.byte 46,0
L126:
	.byte 37,'c,0
L117:
	.byte 32,32,32,0
L110:
	.byte 10,0
L105:
	.byte 10,'D,'A,'T,32,32,32,32,58,45,0
L104:
	.byte 37,48,50,'X,0
L103:
	.byte 10,'S,'D,'T,'O,'K,'E,'N,58,45,0
L96:
	.byte 10,'R,'E,'S,32,32,32,32,58,45,0
L95:
	.byte 37,48,50,'X,32,0
L90:
	.byte 10,'C,'M,'D,32,32,32,32,58,45,0
